//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>
#include <Foundation/Foundation.h>

#ifndef DEBUG_ENUNCIATE
//turn off enunciate debugging.
#define DEBUG_ENUNCIATE 0
#endif

/**
 * Enunciate-specific interfaces and protocols.
 */
#ifndef ENUNCIATE_OBJC_TYPES
#define ENUNCIATE_OBJC_TYPES

/**
 * Protocol defining an Enunciate XML I/O methods.
 */
@protocol EnunciateXML

/**
 * Read an instance from XML.
 *
 * @param xml The XML to read.
 */
+ (id<EnunciateXML>) readFromXML: (NSData *) xml;

/**
 * Write this instance as XML.
 *
 * @return The XML.
 */
- (NSData *) writeToXML;

@end /*protocol EnunciateXML*/


/**
 * A basic XML node. Can be an element or an attribute. Used
 * instead of NSXMLElement because it's not supported on all
 * platforms yet.
 */
@interface JAXBBasicXMLNode : NSObject
{
  @private
    NSString *_name;
    NSString *_ns;
    NSString *_prefix;
    NSString *_value;
    NSArray  *_childElements;
    NSArray  *_attributes;
}

/**
 * Accessor for the (local) name of the XML node.
 *
 * @return The (local) name of the XML node.
 */
- (NSString *) name;

/**
 * Accessor for the (local) name of the XML node.
 *
 * @param newName The (local) name of the XML node.
 */
- (void) setName: (NSString *) newName;

/**
 * Accessor for the namespace of the XML node.
 *
 * @return The namespace of the XML node.
 */
- (NSString *) ns;

/**
 * Accessor for the namespace of the XML node.
 *
 * @param newNs The namespace of the XML node.
 */
- (void) setNs: (NSString *) newNs;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @return The namespace prefix of the XML node.
 */
- (NSString *) prefix;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @param newPrefix The namespace prefix of the XML node.
 */
- (void) setPrefix: (NSString *) newPrefix;

/**
 * Accessor for the value of the XML node.
 *
 * @return The value of the XML node.
 */
- (NSString *) value;

/**
 * Accessor for the value of the XML node.
 *
 * @param newValue The value of the XML node.
 */
- (void) setValue: (NSString *) newValue;

/**
 * Accessor for the child elements of the XML node.
 *
 * @return The child elements of the XML node.
 */
- (NSArray *) childElements;

/**
 * Accessor for the child elements of the XML node.
 *
 * @param newValue The child elements of the XML node.
 */
- (void) setChildElements: (NSArray *) newChildElements;

/**
 * Accessor for the attributes of the XML node.
 *
 * @return The attributes of the XML node.
 */
- (NSArray *) attributes;

/**
 * Accessor for the attributes of the XML node.
 *
 * @param newAttributes The attributes of the XML node.
 */
- (void) setAttributes: (NSArray *) newAttributes;
@end /*interface JAXBBasicXMLNode*/

#endif /* ENUNCIATE_OBJC_TYPES */


@class SECURITY_REST_APINS0RoleResource;
@class SECURITY_REST_APINS0UserChangePasswordRequest;
@class SECURITY_REST_APINS0UserForgotPasswordRequest;
@class SECURITY_REST_APINS0UserResource;
@class SECURITY_REST_APINS0UserToRoleResource;
@class SECURITY_REST_APINS0UserToRoleResourceRequest;
@class SECURITY_REST_APINS0UserResourceRequest;
@class SECURITY_REST_APINS0UserForgotPasswordResource;
@class SECURITY_REST_APINS0UserChangePasswordResource;
@class SECURITY_REST_APINS0RoleResourceRequest;
@class SECURITY_REST_APINS0PlexusUserSearchCriteriaResourceRequest;
@class SECURITY_REST_APINS0PlexusUserSearchCriteriaResource;

#ifndef DEF_SECURITY_REST_APINS0RoleResource_H
#define DEF_SECURITY_REST_APINS0RoleResource_H

/**
 * (no documentation provided)
 */
@interface SECURITY_REST_APINS0RoleResource : NSObject
{
  @private
    NSString *_name;
    NSString *_resourceURI;
    NSArray *_roles;
    int _sessionTimeout;
    NSArray *_privileges;
    NSString *_description;
    BOOL _userManaged;
    NSString *_id;
}

/**
 * (no documentation provided)
 */
- (NSString *) name;

/**
 * (no documentation provided)
 */
- (void) setName: (NSString *) newName;

/**
 * (no documentation provided)
 */
- (NSString *) resourceURI;

/**
 * (no documentation provided)
 */
- (void) setResourceURI: (NSString *) newResourceURI;

/**
 * (no documentation provided)
 */
- (NSArray *) roles;

/**
 * (no documentation provided)
 */
- (void) setRoles: (NSArray *) newRoles;

/**
 * (no documentation provided)
 */
- (int) sessionTimeout;

/**
 * (no documentation provided)
 */
- (void) setSessionTimeout: (int) newSessionTimeout;

/**
 * (no documentation provided)
 */
- (NSArray *) privileges;

/**
 * (no documentation provided)
 */
- (void) setPrivileges: (NSArray *) newPrivileges;

/**
 * (no documentation provided)
 */
- (NSString *) description;

/**
 * (no documentation provided)
 */
- (void) setDescription: (NSString *) newDescription;

/**
 * (no documentation provided)
 */
- (BOOL) userManaged;

/**
 * (no documentation provided)
 */
- (void) setUserManaged: (BOOL) newUserManaged;

/**
 * (no documentation provided)
 */
- (NSString *) id;

/**
 * (no documentation provided)
 */
- (void) setId: (NSString *) newId;
@end /* interface SECURITY_REST_APINS0RoleResource */

#endif /* DEF_SECURITY_REST_APINS0RoleResource_H */
#ifndef DEF_SECURITY_REST_APINS0UserChangePasswordRequest_H
#define DEF_SECURITY_REST_APINS0UserChangePasswordRequest_H

/**
 * (no documentation provided)
 */
@interface SECURITY_REST_APINS0UserChangePasswordRequest : NSObject <EnunciateXML>
{
  @private
    SECURITY_REST_APINS0UserChangePasswordResource *_data;
}

/**
 * (no documentation provided)
 */
- (SECURITY_REST_APINS0UserChangePasswordResource *) data;

/**
 * (no documentation provided)
 */
- (void) setData: (SECURITY_REST_APINS0UserChangePasswordResource *) newData;
@end /* interface SECURITY_REST_APINS0UserChangePasswordRequest */

#endif /* DEF_SECURITY_REST_APINS0UserChangePasswordRequest_H */
#ifndef DEF_SECURITY_REST_APINS0UserForgotPasswordRequest_H
#define DEF_SECURITY_REST_APINS0UserForgotPasswordRequest_H

/**
 * (no documentation provided)
 */
@interface SECURITY_REST_APINS0UserForgotPasswordRequest : NSObject <EnunciateXML>
{
  @private
    SECURITY_REST_APINS0UserForgotPasswordResource *_data;
}

/**
 * (no documentation provided)
 */
- (SECURITY_REST_APINS0UserForgotPasswordResource *) data;

/**
 * (no documentation provided)
 */
- (void) setData: (SECURITY_REST_APINS0UserForgotPasswordResource *) newData;
@end /* interface SECURITY_REST_APINS0UserForgotPasswordRequest */

#endif /* DEF_SECURITY_REST_APINS0UserForgotPasswordRequest_H */
#ifndef DEF_SECURITY_REST_APINS0UserResource_H
#define DEF_SECURITY_REST_APINS0UserResource_H

/**
 * (no documentation provided)
 */
@interface SECURITY_REST_APINS0UserResource : NSObject
{
  @private
    NSString *_email;
    NSString *_firstName;
    NSString *_userId;
    NSString *_lastName;
    NSString *_password;
    NSString *_resourceURI;
    NSString *_status;
    NSArray *_roles;
}

/**
 * (no documentation provided)
 */
- (NSString *) email;

/**
 * (no documentation provided)
 */
- (void) setEmail: (NSString *) newEmail;

/**
 * (no documentation provided)
 */
- (NSString *) firstName;

/**
 * (no documentation provided)
 */
- (void) setFirstName: (NSString *) newFirstName;

/**
 * (no documentation provided)
 */
- (NSString *) userId;

/**
 * (no documentation provided)
 */
- (void) setUserId: (NSString *) newUserId;

/**
 * (no documentation provided)
 */
- (NSString *) lastName;

/**
 * (no documentation provided)
 */
- (void) setLastName: (NSString *) newLastName;

/**
 * (no documentation provided)
 */
- (NSString *) password;

/**
 * (no documentation provided)
 */
- (void) setPassword: (NSString *) newPassword;

/**
 * (no documentation provided)
 */
- (NSString *) resourceURI;

/**
 * (no documentation provided)
 */
- (void) setResourceURI: (NSString *) newResourceURI;

/**
 * (no documentation provided)
 */
- (NSString *) status;

/**
 * (no documentation provided)
 */
- (void) setStatus: (NSString *) newStatus;

/**
 * (no documentation provided)
 */
- (NSArray *) roles;

/**
 * (no documentation provided)
 */
- (void) setRoles: (NSArray *) newRoles;
@end /* interface SECURITY_REST_APINS0UserResource */

#endif /* DEF_SECURITY_REST_APINS0UserResource_H */
#ifndef DEF_SECURITY_REST_APINS0UserToRoleResource_H
#define DEF_SECURITY_REST_APINS0UserToRoleResource_H

/**
 * (no documentation provided)
 */
@interface SECURITY_REST_APINS0UserToRoleResource : NSObject
{
  @private
    NSString *_source;
    NSString *_userId;
    NSArray *_roles;
}

/**
 * (no documentation provided)
 */
- (NSString *) source;

/**
 * (no documentation provided)
 */
- (void) setSource: (NSString *) newSource;

/**
 * (no documentation provided)
 */
- (NSString *) userId;

/**
 * (no documentation provided)
 */
- (void) setUserId: (NSString *) newUserId;

/**
 * (no documentation provided)
 */
- (NSArray *) roles;

/**
 * (no documentation provided)
 */
- (void) setRoles: (NSArray *) newRoles;
@end /* interface SECURITY_REST_APINS0UserToRoleResource */

#endif /* DEF_SECURITY_REST_APINS0UserToRoleResource_H */
#ifndef DEF_SECURITY_REST_APINS0UserToRoleResourceRequest_H
#define DEF_SECURITY_REST_APINS0UserToRoleResourceRequest_H

/**
 * (no documentation provided)
 */
@interface SECURITY_REST_APINS0UserToRoleResourceRequest : NSObject <EnunciateXML>
{
  @private
    SECURITY_REST_APINS0UserToRoleResource *_data;
}

/**
 * (no documentation provided)
 */
- (SECURITY_REST_APINS0UserToRoleResource *) data;

/**
 * (no documentation provided)
 */
- (void) setData: (SECURITY_REST_APINS0UserToRoleResource *) newData;
@end /* interface SECURITY_REST_APINS0UserToRoleResourceRequest */

#endif /* DEF_SECURITY_REST_APINS0UserToRoleResourceRequest_H */
#ifndef DEF_SECURITY_REST_APINS0UserResourceRequest_H
#define DEF_SECURITY_REST_APINS0UserResourceRequest_H

/**
 * (no documentation provided)
 */
@interface SECURITY_REST_APINS0UserResourceRequest : NSObject <EnunciateXML>
{
  @private
    SECURITY_REST_APINS0UserResource *_data;
}

/**
 * (no documentation provided)
 */
- (SECURITY_REST_APINS0UserResource *) data;

/**
 * (no documentation provided)
 */
- (void) setData: (SECURITY_REST_APINS0UserResource *) newData;
@end /* interface SECURITY_REST_APINS0UserResourceRequest */

#endif /* DEF_SECURITY_REST_APINS0UserResourceRequest_H */
#ifndef DEF_SECURITY_REST_APINS0UserForgotPasswordResource_H
#define DEF_SECURITY_REST_APINS0UserForgotPasswordResource_H

/**
 * (no documentation provided)
 */
@interface SECURITY_REST_APINS0UserForgotPasswordResource : NSObject
{
  @private
    NSString *_email;
    NSString *_userId;
}

/**
 * (no documentation provided)
 */
- (NSString *) email;

/**
 * (no documentation provided)
 */
- (void) setEmail: (NSString *) newEmail;

/**
 * (no documentation provided)
 */
- (NSString *) userId;

/**
 * (no documentation provided)
 */
- (void) setUserId: (NSString *) newUserId;
@end /* interface SECURITY_REST_APINS0UserForgotPasswordResource */

#endif /* DEF_SECURITY_REST_APINS0UserForgotPasswordResource_H */
#ifndef DEF_SECURITY_REST_APINS0UserChangePasswordResource_H
#define DEF_SECURITY_REST_APINS0UserChangePasswordResource_H

/**
 * (no documentation provided)
 */
@interface SECURITY_REST_APINS0UserChangePasswordResource : NSObject
{
  @private
    NSString *_oldPassword;
    NSString *_newPassword;
    NSString *_userId;
}

/**
 * (no documentation provided)
 */
- (NSString *) oldPassword;

/**
 * (no documentation provided)
 */
- (void) setOldPassword: (NSString *) newOldPassword;

/**
 * (no documentation provided)
 */
- (NSString *) newPassword;

/**
 * (no documentation provided)
 */
- (void) setNewPassword: (NSString *) newNewPassword;

/**
 * (no documentation provided)
 */
- (NSString *) userId;

/**
 * (no documentation provided)
 */
- (void) setUserId: (NSString *) newUserId;
@end /* interface SECURITY_REST_APINS0UserChangePasswordResource */

#endif /* DEF_SECURITY_REST_APINS0UserChangePasswordResource_H */
#ifndef DEF_SECURITY_REST_APINS0RoleResourceRequest_H
#define DEF_SECURITY_REST_APINS0RoleResourceRequest_H

/**
 * (no documentation provided)
 */
@interface SECURITY_REST_APINS0RoleResourceRequest : NSObject <EnunciateXML>
{
  @private
    SECURITY_REST_APINS0RoleResource *_data;
}

/**
 * (no documentation provided)
 */
- (SECURITY_REST_APINS0RoleResource *) data;

/**
 * (no documentation provided)
 */
- (void) setData: (SECURITY_REST_APINS0RoleResource *) newData;
@end /* interface SECURITY_REST_APINS0RoleResourceRequest */

#endif /* DEF_SECURITY_REST_APINS0RoleResourceRequest_H */
#ifndef DEF_SECURITY_REST_APINS0PlexusUserSearchCriteriaResourceRequest_H
#define DEF_SECURITY_REST_APINS0PlexusUserSearchCriteriaResourceRequest_H

/**
 * (no documentation provided)
 */
@interface SECURITY_REST_APINS0PlexusUserSearchCriteriaResourceRequest : NSObject <EnunciateXML>
{
  @private
    SECURITY_REST_APINS0PlexusUserSearchCriteriaResource *_data;
}

/**
 * (no documentation provided)
 */
- (SECURITY_REST_APINS0PlexusUserSearchCriteriaResource *) data;

/**
 * (no documentation provided)
 */
- (void) setData: (SECURITY_REST_APINS0PlexusUserSearchCriteriaResource *) newData;
@end /* interface SECURITY_REST_APINS0PlexusUserSearchCriteriaResourceRequest */

#endif /* DEF_SECURITY_REST_APINS0PlexusUserSearchCriteriaResourceRequest_H */
#ifndef DEF_SECURITY_REST_APINS0PlexusUserSearchCriteriaResource_H
#define DEF_SECURITY_REST_APINS0PlexusUserSearchCriteriaResource_H

/**
 * (no documentation provided)
 */
@interface SECURITY_REST_APINS0PlexusUserSearchCriteriaResource : NSObject
{
  @private
    NSString *_userId;
    BOOL _effectiveUsers;
}

/**
 * (no documentation provided)
 */
- (NSString *) userId;

/**
 * (no documentation provided)
 */
- (void) setUserId: (NSString *) newUserId;

/**
 * (no documentation provided)
 */
- (BOOL) effectiveUsers;

/**
 * (no documentation provided)
 */
- (void) setEffectiveUsers: (BOOL) newEffectiveUsers;
@end /* interface SECURITY_REST_APINS0PlexusUserSearchCriteriaResource */

#endif /* DEF_SECURITY_REST_APINS0PlexusUserSearchCriteriaResource_H */
